# learn.hasura.io

Real world GraphQL tutorials for frontend developers with deadlines!
With these tutorials, you will move from the basics of GraphQL to building a real-time application in 2 hours

There are three different series:

#### Frontend

- [React](https://learn.hasura.io/graphql/react)
- [Vue](https://learn.hasura.io/graphql/vue)
- Angular (coming soon)
- Elm (coming soon)
- ReasonML (coming soon)

#### Mobile

- [React Native](https://learn.hasura.io/graphql/react-native)
- [iOS](https://learn.hasura.io/graphql/ios)
- Android (coming soon)
- Flutter (coming soon)

#### Backend

- [Introduction to Hasura](https://learn.hasura.io/graphql/hasura)
- Postgres Basics (coming soon)

## What you will learn

### Frontend
- GraphQL vs REST 
- GraphQL Queries, Mutations, Subscriptions
- Setting up a GraphQL Client with Apollo
- Integrating GraphQL Queries in the app
- Integrating GraphQL Mutations with Query Variables
- Integrating Mutations to update, delete and bulk delete
- Managing Local Cache after a GraphQL Mutation
- Optismistic UI updates for responsive user experience
- Using Subscriptions
- Realtime feed with notifications

### Backend

- Hasura Basics
- Postgres Data Modelling
- Authorization
- Authentication
- Custom business logic
- Remote Schemas, Event Triggers

