---
title: "Course introduction"
---

This course is a super fast introduction to setting up a GraphQL backend with Hasura.

In 30 mins, you will setup a powerful, scalable realtime GraphQL backend complete with queries, mutations, subscriptions. You will also learn how Hasura helps you integrate custom business logic (in any programming language), both as custom GraphQL APIs that you write yourself, and as event triggers that run asynchronously and are triggered by database events.

## What will I learn?

This course will help you understand the different Hasura features, when and how to use them, and
is an ideal starting point before diving into advanced topics.

1. Hasura Basics: Use Hasura to generate the realtime GraphQL API powered by a Postgres database
2. Postgres power: Use the power of Postgres to make efficient data transformations so that we don't have to do them in code
3. Authorization: Setup authorization so that app users can only run operations on data that they should be allowed to
4. Authentication: Integrate a JWT based auth provider (using Auth0) with Hasura
3. Remote schemas: Add a custom GraphQL resolver to create an API for fetching data that is not in the database
4. Event triggers: Run business logic on the backend when there are database events


## What will be building?

We will be building the backend of a realtime todo app. If you're interested in building the frontend and are new to GraphQL, head to the GraphQL tutorials for different frontend frameworks:

Try this deployed version of the app, to see what features our backend will need to have:
https://final-graphql-tutorial.netlify.com/

## What do I need to take this tutorial?

Just your browser!

However, be assured that every thing you do via the browser
in this tutorial can be done via code and can be version controlled and
can work with any programming language you choose on the server side.

We've kept this course light on developer workflows and
environment choices so that you can focus on the key concepts and
go on to set up your favourite tools and workflows.

## How long will this tutorial take?
Less than 30 mins.
