# Code de conduite de la communauté Hasura GraphQL Engine

## Notre engagement

Dans le but de cultiver un environnement ouvert et accueillant, en tant que contributeurs
et mainteneurs, nous nous engageons à faire en sorte que la participation à notre projet et
notre communauté soit une expérience exempte de harcellement pour tout le monde, indistinctement
de l'âge, la corpulence, les handicaps, l'ethnie, les caractéristiques sexuelles,
l'identité ou l'expression de genre, le niveau d'expérience, l'éducation,
la catégorié socio-professionnelle, la nationalité, l'apparence personnelle,
la race, la religion ou l'identité et l'orientation sexuelle.

## Nos standards

Exemples de comportements qui contribuent à créer un environnement positif:

* Utiliser un langage accueillant et inclusif
* Être respectueux des points de vue et expériences divergents
* Accepter volontiers les critiques constructives
* Se focaliser sur ce qu'il y a de mieux pour la communauté
* Montrer de l'empathie vis-à-vis des autres membres de la communauté

Exemples de comportements inacceptables de la part des participants:

* L'usage d'un langage ou d'une imagerie à caractère sexuel et l'attention ou les avances
  sexuelles malvenues.
* Le troll, les commentaires insultants/dérogatoires et les attaques personnelles ou politiques
* Le harcellement public ou privé
* La publication d'informations privées telles que l'adresse physique ou électronique d'une personne
  sans son consentement explicite
* Tout autre conduite qui pourrait être raisonablement considérée comme
  inappropriée dans un cadre professionnel

## Nos responsabilités

Les mainteneurs du projet ont la responsabilité de clarifier les standards de ce
qui constitue un comportement acceptable et sont tenus de prendre des mesures correctives
justes et appropriées en réponse à toute occurence de comportement inacceptable.

Les mainteneurs du projet ont le droit et la responsabilité de supprimer, éditer, ou
rejeter les commentaires, commits, code, éditions de wiki, issues et toute autre contribution
qui ne sont pas en accord avec de Code de Conduite, ou de bannir termporairement ou
définitivement tout contributeur pour tout autre comportement qu'ils jugeraient inapproprié,
menaçant, offensant ou dangereux.

## Périmètre

Ce Code de Conduite s'applique à la fois dans les espaces de projet et dans les
espaces publics dés lors qu'un individu représente le projet ou sa communauté.
Des exemples de réprésentation du projet ou de qa communauté incluent l'usage
d'une adresse e-mail officielle du projet, la publication de contenu via un compte
de réseau social officiel, ou le fait d'agir comme un représentant mandaté lors
d'un évènement en-ligne ou hors-ligne. La représentation d'un projet peut être
définie plus précisément par les mainteneurs de ce projet.

## Mise en application

Les occurences de comportement abusif, de harcellement ou de tout autre comportement
inacceptable, peuvent être rapportés en contactant l'équipe du projet via build@hasura.io.
Toute plainte sera revue, examinée et débouchera sur une réponse jugée nécessaire et
appropriée au regard des circonstances. L'équipe du projet est obligée de maintenir
la confidentialité en ce qui concerne le rapporteur d'un incident.
Plus de détails sur des politiques de mise en application spécifiques peuvent être publiées
séparément.

Les mainteneurs du projet qui ne suivent pas ou ne font pas appliquer le Code de Conduite
en toute bonne-foi, s'exposent à de répercussion temporaires ou permanentes, déterminées par
les autres membres de la direction du projet.

## Attribution

Ce Code de Conduite est une adaptation de l'[Engagement de Contributeur][homepage], version 1.4,
disponible sur https://www.contributor-covenant.org/version/1/4/code-of-conduct.html

[homepage]: https://www.contributor-covenant.org
